"""
Exemple de résolution d'équations différentielles :
équation d'ordre 1 : duc/dt + uc/tau = E/tau
"""

from matplotlib.widgets import Cursor
from scipy import *
from pylab import *
from scipy.integrate import odeint      # Module de résolution des équations différentielles

# Coefficients et conditions initiales

R = float(input("entrer la valeur de R (en ohm) :   "))
C = float(input("entrer la valeur de C (en farad):    "))
n = int(input("entrer un multiple de tau:..."))
u0 = 0
E = 5 # valeur par défaut en sortie digitale sur Arduino

# calcul de tau theorique
def calculTau(R,C):
    tau = R*C         # à compléter
    return tau

tau=calculTau(R,C)
print("Valeur de tau :",round(tau,2), " s")
Fin=n*tau

# Création des valeurs de dérivée
def deriv(syst, t):
    y = syst[0]                         # Variable y(t) ici uc(t)
    dydt=-y/tau + E/tau                 # Equation différentielle
    return [dydt]                       # Dérivées des variables

# Paramètres d'intégration
start = 0
end = Fin
numsteps = 200
t = linspace(start,end,numsteps)

# Résolution
y0=u0
syst_CI=array([y0])                     # Tableau des CI
Sols=odeint(deriv,syst_CI,t)            # Résolution numérique de l'équation différentielle

# Récupération des solutions
y = Sols[:, 0]

# Graphique
fig=subplot()
plot ( t , y, 'b-*', linewidth=1,  label="Charge d'un condensateur")
grid()
xlabel("t (s)", fontsize=16)            # Label de l'axe des abscisses
ylabel("uc (V)", fontsize=16)           # Label de l'axe des ordonnées
legend(loc = 'best')

# curseur pour lire une valeur
Cursor(fig, useblit=True, color='red', linewidth=1)
show()



